"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _babelConfigCacheIdentifier = require("./babel-config-cache-identifier");

var _jsonString = require("./json-string");

var _default = {
  generate: val => (0, _jsonString.toJSONString)(val),
  diff: (oldIdent, newIdent) => {
    const newVal = (0, _jsonString.parseJSONString)(newIdent);

    if (oldIdent == null) {
      (0, _babelConfigCacheIdentifier.printBabelConfigCacheIdentifierDiff)(null, newVal.babelConfig);
      return ['new'];
    }

    const oldVal = (0, _jsonString.parseJSONString)(oldIdent);
    return Object.keys(newVal).reduce((acc, key) => {
      if (newVal[key] !== oldVal[key]) {
        if (key === 'babelConfig') {
          (0, _babelConfigCacheIdentifier.printBabelConfigCacheIdentifierDiff)(oldVal.babelConfig, newVal.babelConfig);
        }

        acc.push(key);
      }

      return acc;
    }, []);
  }
};
exports.default = _default;